<template>
  <div>
    <div class="dashboard__header">
      <h1 class="dashboard__title">مدیریت محصولات</h1>
      <div class="dashboard__actions">
        <ResponsiveComponent>
          <Button type="outlined" color='dark' light size="sm" @click.native="$router.push('/dashboard/admin/products/create')">
            <template #icon>
              <AddIcon />
            </template>
            محصول جدید
          </Button>
          <template #collapsed>
            <Button type="text" round color='dark' light size="sm" @click.native="$router.push('/dashboard/admin/products/create')">
              <template #icon>
                <AddIcon />
              </template>
            </Button>
          </template>
        </ResponsiveComponent>
        <Button type="text" color='dark' light round size="sm" @click.native="$router.push('/dashboard')">
          <template #icon>
            <BackIcon />
          </template>
        </Button>
      </div>
    </div>
    <div class="dashboard__body">
      <DashboardNavigation class="dashboard__nav" active="products" />
      <Card title="محصولات" class="dashboard__content">
        <template #actions>
          <p class="count">
            {{ count }} عدد
          </p>
        </template>
        <div v-if="!products.length > 0" class="empty">
          <EmptyIcon class="empty__icon"/>
          <p class="empty__text">دسته بندی برای نمایش وجود ندارد.</p>
        </div>
        <ManagingItemRow v-for="product in products" :key="product.id" :item="product" baseEditPath="/dashboard/admin/products" @delete="onDelete" />
      </Card>
    </div>
  </div>
</template>

<script>
import DashboardNavigation from "@/components/layout/DashboardNavigation";
import ManagingItemRow from "@/components/dashboard/ManagingItemRow";
import BackIcon from "@/assets/svgs/back.svg";
import Button from "@/components/base/Button";
import Card from "@/components/base/Card";
import AddIcon from "@/assets/svgs/add.svg";
import EmptyIcon from "@/assets/svgs/empty_box.svg";
import ResponsiveComponent from "@/components/base/ResponsiveComponent";

export default {
  components: {
    DashboardNavigation,
    ManagingItemRow,
    BackIcon,
    AddIcon,
    Button,
    Card,
    EmptyIcon,
    ResponsiveComponent
  },
  head() {
    return {
      title: "مدیریت محصولات"
    }
  },
  layout: "dashboard",
  async asyncData(context) {
    let products = [];
    let count = 0;
    await context.store.dispatch('shop/fetchProducts').then(response => {
      if (response.status === 200) {
        products = response.data.data;
        count = response.data.meta.total;
      }
    }).catch(error => {
      console.log(error);
    });
    return {
      products,
      count
    }
  },
  methods: {
    onDelete(id) {
      this.$store.dispatch('shop/deleteProduct', {
        token: this.$store.getters['auth/getToken'],
        id: id
      }).then(response => {
        if (response.status === 200) {
          this.$store.dispatch('notifications/push', {
            message: "محصول انتخاب شده با موفقیت حذف شد.",
            light: true,
            type: "success",
            timeout: 3000
          });
          this.products = this.products.filter(cur => cur.id !== id);
          this.count--;
        }
      }).catch(error => {
        if (error.response.status === 404) {
          this.$store.dispatch('notifications/push', {
            message: "محصول انتخاب شده برای حذف یافت نشد.",
            type: "error",
            timeout: 3500
          });
        } else {
          this.$store.dispatch('notifications/push', {
            message: "خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره امتحان کنید.",
            type: "error",
            timeout: 3500
          });
        }
      });
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.dashboard__content
  align-self flex-start

.count
  opacity .6
  color $grey 

.empty
  display flex
  align-items center
  justify-content center
  flex-direction column
  padding $sm 0
  &__icon
    width 10rem
    height 10rem
    fill $grey
    opacity .7
  &__text
    margin-top $xxsm
    color $grey
</style>